<?php
/**
 * Livewire Component
 *
 * @version     1.0.$Revision:$
 * @version     SVN: $Id:$
 * @package     bplan-base/globals
 * @subpackage  LivewireComponents
 * @author      Emilio Cannarozzo <emilio.cannarozzo@bplan-solutions.de>
 * @author      Wassilios Meletiadis <wassilios.meletiadis@bplan-solutions.de>
 * @copyright   Copyright (C) 2025, 2026 bplan-solutions GmbH & Co. KG <https://www.bplan-solutions.de/>
 * /Δ\
 */

namespace BplanBase\Globals\Livewire\Core\User;


use BplanBase\Globals\DataGrid\DataGrid;
use BplanBase\Globals\Enums\UserAccessLevel;
use BplanBase\Globals\Models\User;
use BplanBase\Globals\Repositories\IndexCollectionRepository;
use BplanBase\Globals\Traits\WithDataGrid;
use Illuminate\Pagination\LengthAwarePaginator;
use Livewire\Component;
use Livewire\WithPagination;


/**
 * Livewire Component
 *
 * @version     1.0.0 / 2026-05-25
 * @author      Emilio Cannarozzo <emilio.cannarozzo@bplan-solutions.de>
 * @author      Wassilios Meletiadis <wassilios.meletiadis@bplan-solutions.de>
 */
class Index extends Component
{


/* +++ TRAITS +++ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */


    use WithDataGrid;
    use WithPagination;


/* +++ CLASS CONSTANTS +++ ++++++++++++++++++++++++++++++++++++++++++++++++++ */


/* +++ OBJECT MEMBERS +++ +++++++++++++++++++++++++++++++++++++++++++++++++++ */


    /**
     * @var     array
     */
    protected array $_formatCasts = [
        'active'            => 'boolean',
        'created_at'        => 'datetime',
        'deleted_at'        => 'datetime',
        'email_verified_at' => 'datetime',
        'internal'          => 'boolean',
        'restricted'        => 'boolean',
        'updated_at'        => 'datetime',
    ];


    /**
     * Specifies the columns to use and their order
     *
     * @var     array
     */
    protected array $_gridColumns = [
        'id',
        'name',
        'email',
        'active',
        'internal',
        'restricted',
    ];


    /**
     * @var     string
     */
    protected string $_gridLocaleFile = 'globals::users';


    /**
     * @var     string
     */
    protected string $_modelClass = User::class;


    /**
     * @var     array
     */
    protected array $_searchFields = [
        'email',
        'name',
    ];


    /**
     * @var     array
     */
    protected $listeners = [
        'user-created' => 'render',
        'user-saved'   => 'render',
    ];


/* +++ CLASS MEMBERS +++ ++++++++++++++++++++++++++++++++++++++++++++++++++++ */


/* +++ OBJECT METHODS +++ +++++++++++++++++++++++++++++++++++++++++++++++++++ */


    /**
     *
     * @return      LengthAwarePaginator<User>
     *
     * @version     1.0.0 / 2026-05-25
     * @author      Emilio Cannarozzo <emilio.cannarozzo@bplan-solutions.de>
     * @author      Wassilios Meletiadis <wassilios.meletiadis@bplan-solutions.de>
     */
    private function _getData(): LengthAwarePaginator
    {
        return IndexCollectionRepository::getUsers(
            ExtendQuery: $this->_getQuery(),
            orderBy:     $this->_getOrderBy(),
            paginate:    ['pageName' => 'users-page'],
            withInactive: true,
            withInternal: \Registry::get('core.user')->hasMinAccessLevel(UserAccessLevel::Maintainer)
        );

    } // _getData()


    /**
     *
     * @return      DataGrid
     *
     * @version     1.0.0 / 2026-05-25
     * @author      Emilio Cannarozzo <emilio.cannarozzo@bplan-solutions.de>
     * @author      Wassilios Meletiadis <wassilios.meletiadis@bplan-solutions.de>
     */
    private function _getGrid(): DataGrid
    {
        $gridData = $this->_getData();

        return (new DataGrid('user'))
            ->setActions([
                'edit-user',
            ])
            ->setActionSvgIcons([
                'edit-user' => svg_icon('globals.svg-icons.action-edit'),
            ])
            ->setActiveFilters($this->_hasActiveFilters())
            ->setColumnCallback(function ($Item, $property, $value) {
                switch ($property) {
                    case 'active':
                        if ($value === true) {
                            $value = svg_icon('globals.svg-icons.status-active', 'data-tippy-content="'.__('globals::global.status.active').'"');
                        } else {
                            $value = svg_icon('globals.svg-icons.status-inactive', 'data-tippy-content="'.__('globals::global.status.inactive').'"');
                        }
                        break;

                    case 'internal':
                        if ($value === true) {
                            $value = svg_icon('globals.svg-icons.status-active', 'data-tippy-content="'.__('globals::global.status.active').'"');
                        } else {
                            $value = svg_icon('globals.svg-icons.status-inactive', 'data-tippy-content="'.__('globals::global.status.inactive').'"');
                        }
                        break;

                    case 'restricted':
                        if ($value === true) {
                            $value = svg_icon('globals.svg-icons.status-active', 'data-tippy-content="'.__('globals::global.status.active').'"');
                        } else {
                            $value = svg_icon('globals.svg-icons.status-inactive', 'data-tippy-content="'.__('globals::global.status.inactive').'"');
                        }
                        break;

                }
                return $value;
            })
            ->setColumns($this->_gridColumns)
            ->setData($gridData)
            ->setLocaleFile($this->_gridLocaleFile)
            ->setSorting($this->sortColumns, $this->sortColumn, $this->sortDirection)
            ->useCaptions(true)
            ->useDefaultCreateButton(true)
            ->useDefaultSearch(true);

    } // _getGrid()


    /**
     *
     * @version     1.0.0 / 2026-05-25
     * @author      Emilio Cannarozzo <emilio.cannarozzo@bplan-solutions.de>
     * @author      Wassilios Meletiadis <wassilios.meletiadis@bplan-solutions.de>
     */
    public function render()
    {
        return view('globals::livewire.core.user.index', [
            'grid' => $this->_getGrid(),
        ]);

    } // render()


/* +++ CLASS METHODS +++ ++++++++++++++++++++++++++++++++++++++++++++++++++++ */


} // class Index extends Component {}
